Attribute VB_Name = "Keyboardhandler"
' Keyboardhandler.bas - Demonstrates low-level keyboard hooks
' Copyright (c) 2002. All Rights Reserved
' By Paul Kimmel. pkimmel@softconcepts.com

'http://msdn.microsoft.com/library/default.asp?url=
'/library/en-us/winui/WinUI/WindowsUserInterface
'/Windowing/Hooks/HookReference/HookFunctions/LowLevelKeyboardProc.asp

Option Explicit

Public Declare Function UnhookWindowsHookEx Lib "user32" _
  (ByVal hHook As Long) As Long

Public Declare Function SetWindowsHookEx Lib "user32" _
  Alias "SetWindowsHookExA" (ByVal idHook As Long, _
                             ByVal lpfn As Long, _
                             ByVal hmod As Long, _
                             ByVal dwThreadId As Long) As Long
  
Private Declare Sub CopyMemory Lib "kernel32" _
   Alias "RtlMoveMemory" _
  (pDest As Any, _
   pSource As Any, _
   ByVal cb As Long)

Private Declare Function GetAsyncKeyState Lib "user32" _
  (ByVal vKey As Long) As Integer

Private Declare Function CallNextHookEx Lib "user32" _
   (ByVal hHook As Long, _
   ByVal nCode As Long, _
   ByVal wParam As Long, _
   ByVal lParam As Long) As Long


Private Type KBDLLHOOKSTRUCT
  vkCode As Long
  scanCode As Long
  flags As Long
  time As Long
  dwExtraInfo As Long
End Type

' Low-Level Keyboard Constants
Private Const HC_ACTION = 0
Private Const LLKHF_EXTENDED = &H1
Private Const LLKHF_INJECTED = &H10
Private Const LLKHF_ALTDOWN = &H20
Private Const LLKHF_UP = &H80

' Virtual Keys
Public Const VK_SHIFT = &H10
Public Const VK_MENU = &H12 ' alt
Public Const VK_TAB = &H9
Public Const VK_CONTROL = &H11
Public Const VK_ESCAPE = &H1B
Public Const VK_DELETE = &H2E
Public Const VK_SPACE = &H20

Private Const WH_KEYBOARD_LL = 13&
Public KeyboardHandle As Long

Public KeyboardHook As KeyboardHook

Public m_MyHooked As Boolean


' Implement this function to block as many key combinations as
' you'd like
Public Function IsHooked(ByRef Hookstruct As KBDLLHOOKSTRUCT) _
            As Boolean
   
  If (KeyboardHook Is Nothing) Then
    IsHooked = False
    Exit Function
  End If
  
  g_iCount = g_iCount + 1
  
    If m_MyHooked And g_iCount Mod 2 = 0 Then
        'Debug.Print Hookstruct.vkCode
    

    
        DBOpen
        
'        Debug.Print "Ctrl: " & CBool(GetAsyncKeyState(VK_CONTROL))
'        Debug.Print "Shif: " & CBool(GetAsyncKeyState(VK_SHIFT))
'        Debug.Print "Alt : " & CBool(GetAsyncKeyState(VK_MENU))
  
  
        Dim bCtrl As Boolean
        Dim bShift As Boolean
        Dim bAlt As Boolean
        
        bCtrl = CBool(GetAsyncKeyState(VK_CONTROL))
        bShift = CBool(GetAsyncKeyState(VK_SHIFT))
        bAlt = CBool(GetAsyncKeyState(VK_MENU))
    
        Dim rMIDIKeys As ADODB.Recordset
        Set rMIDIKeys = CreateObject("ADODB.Recordset")
        cmdTemp.CommandText = "SELECT tblMIDIKeys.* " _
            & "From tblMIDIKeys;"
        rMIDIKeys.Open cmdTemp, , adOpenKeyset, adLockOptimistic
        Do Until rMIDIKeys.EOF
            'Debug.Print Asc(rMIDIKeys("Keys"))
            
            If rMIDIKeys("Key1") = "Ctrl" And bCtrl Then
                If rMIDIKeys("Key2") = "Alt" And bAlt And Not bShift Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                    End If
                ElseIf rMIDIKeys("Key2") = "Shift" And bShift Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                ElseIf Not bShift And Not bAlt Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key2")) And Not rMIDIKeys("Key2") = "Shift" Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                End If
            ElseIf rMIDIKeys("Key1") = "Alt" And bAlt Then
                If rMIDIKeys("Key2") = "Ctrl" And bCtrl And Not bShift Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                ElseIf rMIDIKeys("Key2") = "Shift" And bShift Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                ElseIf Not bShift And Not bCtrl Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key2")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                End If
            ElseIf rMIDIKeys("Key1") = "Shift" And bShift Then
                If rMIDIKeys("Key2") = "Alt" And bAlt And Not bCtrl Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                ElseIf rMIDIKeys("Key2") = "Ctrl" And bCtrl Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                ElseIf Not bAlt And Not bCtrl Then
                    If Hookstruct.vkCode = Asc(rMIDIKeys("Key2")) Then
                        Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
                        'Call frmMIDIKeys.NoteOn(rMIDIKeys("MIDI"), 127)
                        'Call frmMIDIKeys.NoteOff(rMIDIKeys("MIDI"))
                        frmMIDIKeys.Timer1.Enabled = True
                        g_iNote = rMIDIKeys("MIDI")
                    End If
                End If
            ElseIf Not bShift And Not bCtrl And Not bAlt Then
                If Hookstruct.vkCode = Asc(rMIDIKeys("Key1")) And Not rMIDIKeys("Key1") = "Alt" And Not rMIDIKeys("Key1") = "Ctrl" And Not rMIDIKeys("Key1") = "Shift" Then
'                    Debug.Print "oi: " & Asc(rMIDIKeys("Key1"))
'                    Debug.Print "Ctrl: " & bCtrl
'                    Debug.Print "Shif: " & bShift
'                    Debug.Print "Alt : " & bAlt
                    Debug.Print rMIDIKeys("Key1") & " " & rMIDIKeys("Key2") & " " & rMIDIKeys("Key3")
''                    frmMIDIKeys.NoteOn rMIDIKeys("MIDI"), 127
'                    frmMIDIKeys.NoteOff rMIDIKeys("MIDI")
                    frmMIDIKeys.Timer1.Enabled = True
                    g_iNote = rMIDIKeys("MIDI")
                End If
            End If
            
            
            'If (rMIDIKeys("Key1") = "Ctrl" Or rMIDIKeys("Key2") = "Ctrl" Or rMIDIKeys("Key3") = "Ctrl") _
            '    And CBool(GetAsyncKeyState(VK_CONTROL)) Then
            '    If Hookstruct.vkCode = Asc(rMIDIKeys("Key1")) Or Hookstruct.vkCode = Asc(rMIDIKeys("Key2")) Or Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
            '        Debug.Print rMIDIKeys("Keys")
            '    End If
            'ElseIf a = a Then
            '    If Hookstruct.vkCode = Asc(rMIDIKeys("Key1")) Or Hookstruct.vkCode = Asc(rMIDIKeys("Key2")) Or Hookstruct.vkCode = Asc(rMIDIKeys("Key3")) Then
            '        Debug.Print rMIDIKeys("Keys")
            '    End If
            'End If
            
            
            rMIDIKeys.MoveNext
        Loop
        rMIDIKeys.Close
        Set rMIDIKeys = Nothing
        DB.Close
        Set DB = Nothing
        
    
'        If (Hookstruct.vkCode = VK_ESCAPE) And _
'          CBool(GetAsyncKeyState(VK_CONTROL) _
'          And &H8000) Then
'
'          IsHooked = KeyboardHook.BlockControlEscape
'
'          Call HookedState(IsHooked, "Ctrl + Esc blocked")
'          Exit Function
'        End If
'
'        If (Hookstruct.vkCode = VK_TAB) And _
'          CBool(Hookstruct.flags And _
'          LLKHF_ALTDOWN) Then
'
'          IsHooked = KeyboardHook.BlockAltTab
'
'          Call HookedState(IsHooked, "Alt + Tab blocked")
'          Exit Function
'        End If
'
          If (Hookstruct.vkCode = VK_SPACE) Then

          IsHooked = KeyboardHook.BlockSpace

          Call HookedState(IsHooked, "Spacebar blocked")
          Exit Function
        End If
'
'
'        If (Hookstruct.vkCode = VK_ESCAPE) And _
'          CBool(Hookstruct.flags And _
'            LLKHF_ALTDOWN) Then
'
'          IsHooked = KeyboardHook.BlockAltEscape
'
'          Call HookedState(IsHooked, "Alt + Escape blocked")
'          Exit Function
'        End If
    End If
End Function

Private Sub HookedState(ByVal Hooked As Boolean, _
                        ByVal Text As String)
If (Hooked) Then Debug.Print Text
End Sub


Public Function KeyboardCallback(ByVal Code As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long

  Static Hookstruct As KBDLLHOOKSTRUCT

  If (Code = HC_ACTION) Then
    ' Copy the keyboard data out of the lParam (which is a pointer)
    Call CopyMemory(Hookstruct, ByVal lParam, Len(Hookstruct))

    If (IsHooked(Hookstruct)) Then
      KeyboardCallback = 1
      Exit Function
    End If

  End If

  KeyboardCallback = CallNextHookEx(KeyboardHandle, _
    Code, wParam, lParam)

End Function

Public Sub HookKeyboard()
  KeyboardHandle = SetWindowsHookEx( _
    WH_KEYBOARD_LL, AddressOf KeyboardCallback, _
    App.hInstance, 0&)

  Call CheckHooked
End Sub

Public Sub CheckHooked()
  If (Hooked) Then
    Debug.Print "Keyboard hooked"
  Else
    Debug.Print "Keyboard hook failed: " & Err.LastDllError
  End If
End Sub

Private Function Hooked()
  Hooked = KeyboardHandle <> 0
End Function

Public Sub UnhookKeyboard()
  If (Hooked) Then
    Call UnhookWindowsHookEx(KeyboardHandle)
  End If
End Sub
