Attribute VB_Name = "modCommon"
Option Explicit
Public g_bAgree As Boolean
Public g_bRegOk As Boolean
Public g_arrStatsData() As String
Public g_iLogLinkID As Integer
Public g_iCount As Integer
Public g_iNote As Integer

Public Function CleanURL(ByVal URL As String)
    'Make sure dirs have a / on the end
    Dim sURL As String
    sURL = Trim(URL)
    sURL = Replace(sURL, "http://", "")
    If Not InStrRev(sURL, "/") = Len(sURL) Then
        Dim iLastSlash As Integer
        iLastSlash = InStrRev(sURL, "/")
        If iLastSlash = 0 Then
            iLastSlash = 1
        End If
        If Len(Mid(sURL, iLastSlash)) > 0 Then
            If Not InStr(1, Mid(sURL, iLastSlash), ".", vbTextCompare) > 0 Then
                sURL = sURL & "/"
            ElseIf Not InStr(1, sURL, "/") > 0 Then
                sURL = sURL & "/"
            End If
        End If
    End If
    sURL = "http://" & sURL
    
    CleanURL = sURL
    
End Function

Public Function FileExists(ByVal strPath As String) As Integer
    Dim lngRetVal As Long
    On Error Resume Next
    If strPath <> "" Then
        lngRetVal = Len(Dir$(strPath))
        If Err Or lngRetVal = 0 Then
            FileExists = False
        Else
            FileExists = True
        End If
    Else
        FileExists = False
    End If
    Err.Clear
    On Error GoTo 0
End Function

Public Function Replace(ByVal strSent As String, ByVal strLookFor As String, ByVal strReplaceWith As String, Optional CaseSensitive As Boolean = False, Optional ByRef MaxReplace As Long) As String
      
    Dim pointer As Long
    Dim dataOK As Boolean
    Dim RetCode As Integer
    RetCode = 0
    
    'test input
    dataOK = True
    If strLookFor = strReplaceWith Then dataOK = False
    If strLookFor = "" Then dataOK = False
    
    'replace everything!
    If dataOK Then
        If CaseSensitive Then
            pointer = InStr(1, strSent, strLookFor, vbBinaryCompare)
        Else
            pointer = InStr(1, strSent, strLookFor, vbTextCompare)
        End If
        If pointer > 0 Then
            Do While (pointer > 0) And (MaxReplace = 0 Or MaxReplace > RetCode)
                strSent = Left(strSent, pointer - 1) & strReplaceWith & Right(strSent, Len(strSent) - Len(strLookFor) - pointer + 1)
                RetCode = RetCode + 1
                pointer = pointer + Len(strReplaceWith)
                If CaseSensitive Then
                    pointer = InStr(pointer, strSent, strLookFor, vbBinaryCompare)
                Else
                    pointer = InStr(pointer, strSent, strLookFor, vbTextCompare)
                End If
            Loop
        End If
    End If
    
    Replace = strSent

End Function


Public Function HexStr2Bytes(str As String, aBytes() As Byte) As Integer
' Converts string <str> with hex values into array of bytes
' Returns # of bytes converted
' Assumes array is large enough
' E.g. "fedcba98" will be converted into (&HFE, &HDC, &HBA, &H98)
    Dim i As Integer
    Dim nBytes As Long
    
    nBytes = Len(str) \ 2
    For i = 0 To nBytes - 1
        aBytes(i) = CByte("&H" & Mid(str, i * 2 + 1, 2))
    Next
    
    HexStr2Bytes = nBytes
    
End Function

Public Function Bytes2String(aBytes() As Byte, nBytes As Long) As String
' Converts array of bytes, nBytes long, into a string
' E.g. (&H61, &H62, &H63) will be converted to "abc"
    Dim i As Integer
    Dim str As String
    
    For i = 0 To nBytes - 1
        str = str & Chr(aBytes(i))
    Next
    
    Bytes2String = str
    
End Function

Public Function Str2Hex(ByVal str As String) As String
' Converts string <str> of chars to string in hex byte format
' E.g. "abc" will be converted to "616263"
    Dim byt As Byte
    Dim i As Integer
    Dim n As Integer
    Dim sHex As String
    sHex = ""
    
    n = Len(str)
    For i = 1 To n
        byt = CByte(Asc(Mid$(str, i, 1)))
        If Len(Hex(byt)) = 1 Then
            sHex = sHex & "0" & Hex(byt)
        Else
            sHex = sHex & Hex(byt)
        End If
        DoEvents
    Next
    Str2Hex = sHex
    
End Function

'Public Function GetStats()
'    On Error GoTo GetStats_Err
'
'    ReDim g_arrStatsData(0 To 1, 0 To 3)
'    Dim sStats As String
'    If FileExists(App.Path & "\stats.txt") Then
'        Open App.Path & "\stats.txt" For Input As #1
'        sStats = Input(LOF(1), #1)
'        Close #1
'
'        Dim arrLines() As String
'        Dim arrHits() As String
'
'        If sStats <> "" Then
'            arrLines() = Split(sStats, vbCrLf)
'
'            ReDim g_arrStatsData(0 To UBound(arrLines()), 0 To 3)
'
'            Dim rSub As ADODB.Recordset
'            Set rSub = CreateObject("ADODB.Recordset")
'            Dim x, y, iCount As Integer
'            'Loop thru each line of file
'            If UBound(arrLines()) >= 0 Then
'                For x = 0 To UBound(arrLines())
'                    If InStr(arrLines(x), "|") > 0 Then
'                        arrHits() = Split(arrLines(x), "|")
'                        For y = 0 To UBound(arrHits())
'                            g_arrStatsData(iCount, y) = arrHits(y)
'                        Next
'
'                        cmdTemp.CommandText = "SELECT tblSubmission.SubURL, tblLinks.MainURL, tblSubmission.SubDate " _
'                            & "FROM tblLinks INNER JOIN tblSubmission ON tblLinks.LinkID = tblSubmission.LinkID " _
'                            & "WHERE (((tblSubmission.SubURL)='" & arrHits(0) & "') " _
'                            & "AND ((tblLinks.MainURL) Like '" & arrHits(1) & "%'));"
'                        rSub.Open cmdTemp, , adOpenKeyset, adLockOptimistic
'                        If Not rSub.EOF Then
'                            g_arrStatsData(iCount, y) = rSub("SubDate")
'                        End If
'                        rSub.Close
'                        iCount = iCount + 1
'                    End If
'                    Erase arrHits
'                    DoEvents
'                Next
'            End If
'            Set rSub = Nothing
'            'frmMain.GridEXStats.ItemCount = iCount
'        End If
'    End If
'
'GetStats_Exit:
'    On Error Resume Next
'    If Not rSub Is Nothing Then
'        rSub.Close
'        Set rSub = Nothing
'    End If
'    If Not DB Is Nothing Then
'        DB.Close
'        Set DB = Nothing
'    End If
'    Exit Function
'GetStats_Err:
'    'Err.Raise Err.Number, "GetStats", Err.Description
'    DisplayErr "GetStats", "modCommon", Err.Description
'    Resume GetStats_Exit
'End Function

Public Function DisplayErr(ByVal ErrFunction As String, ByVal ErrForm As String, ByVal ErrDescription As String)

    Dim iMsgReturn As Integer
    iMsgReturn = MsgBox("An Error has occured in the """ & ErrFunction & """ module." & vbCrLf & vbCrLf _
        & "Click Yes to send bug report to mr-yellow@mr-yellow.com" & vbCrLf & vbCrLf _
        & "Form: " & ErrForm & vbCrLf _
        & "Module: " & ErrFunction & vbCrLf _
        & "Description: " & ErrDescription, vbYesNo, "LinkUp Error")
    If iMsgReturn = 6 Then
        On Error Resume Next
'        Dim SendMail As ASPEMAILLib.MailSender
'        Set SendMail = CreateObject("Persits.MailSender")
'
'        Dim sEmailUser, sEmailPass, sEmailServer As String
'        sEmailServer = GetSetting("LinkUp", "Servers", "Email")
'        sEmailUser = GetSetting("LinkUp", "Servers", "EmailUser", "")
'        sEmailPass = GetSetting("LinkUp", "Servers", "EmailPass", "")
'
'        If sEmailUser <> "" And sEmailPass <> "" Then
'            SendMail.Username = sEmailUser
'            SendMail.Password = sEmailPass
'        End If
'
'        SendMail.From = "bugs@mr-yellow.com"
'        SendMail.FromName = "Bug"
'        SendMail.Host = sEmailServer
'        SendMail.Helo = "LinkUp"
'        SendMail.Subject = "LinkUp: Bug Report"
'
'        SendMail.AddAddress "bugs@mr-yellow.com"
'
'        SendMail.Body = "User: " & GetSetting("LinkUp", "Licence", "Reg3") & vbCrLf _
'            & "Email: " & GetSetting("LinkUp", "Info", "Email", "") & vbCrLf _
'            & "Version: " & App.Major & "." & App.Minor & vbCrLf _
'            & "Form: " & ErrForm & vbCrLf _
'            & "Module: " & ErrFunction & vbCrLf _
'            & "Description: " & ErrDescription
'
'        SendMail.Send
'        SendMail.Reset
'        Set SendMail = Nothing
        On Error GoTo 0
    End If
End Function

